import { IService } from "./Service";
export interface StoreListener<StateT> {
    (newState: StateT, oldState: StateT): void;
}
export declare class AppStore<StateT extends object> {
    private listeners;
    private appState;
    private stores;
    constructor();
    init(stores: IService<any>[]): void;
    getState(): StateT;
    subscribe(listener: (newState, oldState) => void): void;
    unsubscribe(listener: (newState, oldState) => void): void;
    commit(oldState: any, newState: any): StateT;
    private emit(oldState, newState);
    private registerStore<StateT>(store);
    private findConflictingPath(path);
}
